import 'dart:io';

import 'package:logger4flutter/models/constants.dart';
import 'package:logger4flutter/utils/utils.dart';
import 'package:path_provider/path_provider.dart';

class LogFile {
  String _directoryName;
  LogFile._();

  static final LogFile _singleton = LogFile._();

  static LogFile getInstance({
    String directoryName = Constants.defaultDirectoryName,
  }) {
    _singleton._directoryName = directoryName;

    return _singleton;
  }

  Future<String> readLog() async {
    try {
      final file = await _file;
      return file.readAsString();
    } catch (err) {
      throw err;
    }
  }

  Future<File> writeLog(String log) async {
    try {
      final file = await _file;
      return file.writeAsString(log);
    } catch (err) {
      throw err;
    }
  }

  Future<String> get _appPath async {
    Directory directory = await getApplicationDocumentsDirectory();
    return directory.path;
  }

  Future<File> get _file async {
    final path = await _appPath + "/" + _directoryName;

    await Directory(path).create();
    String fileName = LoggerUtils.getCurrentDateString();
    File file = File("$path/$fileName.log");

    return file;
  }
}
