import 'package:logger4flutter/models/abstracts.dart';
import 'package:logger4flutter/models/enums.dart';

class LoggerConfigImpl implements LoggerConfig {
  LoggerLevel _printLevel;
  LoggerLevel _fileLevel;
  String _fileDirectoryName;
  LoggerLevel _serverLevel;
  String _serverUrl;

  LoggerConfigImpl._();
  static final LoggerConfigImpl _singleton = LoggerConfigImpl._();

  static LoggerConfigImpl getInstance({
    LoggerLevel printLevel = LoggerLevel.off,
    LoggerLevel fileLevel = LoggerLevel.off,
    String fileDirectoryName,
    LoggerLevel serverLevel = LoggerLevel.off,
    String serverUrl,
  }) {
    _singleton.updateConfig(
        printLevel, fileLevel, fileDirectoryName, serverLevel, serverUrl);
    return _singleton;
  }

  @override
  updateConfig(
    LoggerLevel printLevel,
    LoggerLevel fileLevel,
    String fileDirectoryName,
    LoggerLevel serverLevel,
    String serverUrl,
  ) {
    this._printLevel = printLevel;
    this._fileLevel = fileLevel;
    this._fileDirectoryName = fileDirectoryName;
    this._serverLevel = serverLevel;
    this._serverUrl = serverUrl;
  }

  LoggerLevel get printLevel => _printLevel;
  LoggerLevel get fileLevel => _fileLevel;
  String get fileDirectoryName => _fileDirectoryName;
  LoggerLevel get serverLevel => _serverLevel;
  String get serverUrl => _serverUrl;
}
