import 'package:logger4flutter/models/enums.dart';

abstract class LoggerConfig {
  LoggerLevel get printLevel;
  LoggerLevel get fileLevel;
  String get fileDirectoryName;
  LoggerLevel get serverLevel;
  String get serverUrl;

  updateConfig(
    LoggerLevel printLevel,
    LoggerLevel fileLevel,
    String fileDirectoryName,
    LoggerLevel serverLevel,
    String serverUrl,
  );
}

abstract class Logger {
  String get name;

  trace(String message);
  debug(String message);
  info(String message);
  warn(String message);
  error(String message);
  fatal(String message);
}
